import { defineComponent as D, computed as d, ref as C, watch as N, resolveComponent as K, openBlock as u, createElementBlock as f, normalizeClass as z, unref as t, createBlock as k, mergeProps as g, isRef as v, createCommentVNode as O, createElementVNode as A, Fragment as P, renderList as R, createVNode as j } from "vue";
import { isArray as x, isString as I, isEqual as T } from "lodash-es";
import { a6 as Y, a7 as q, a9 as G, ae as H, P as J, o as y, ak as Q, ar as W } from "./index-0a39b082.js";
import { m as X } from "./mediaFilter-3fdbc89b.js";
import "axios";
import "@vueuse/core";
import "vue-i18n";
const Z = `.kapix-image-viewer-input{width:100%;height:100%;min-width:0;min-height:0;display:flex;flex-direction:row;overflow:auto}.kapix-image-viewer-input::-webkit-scrollbar-thumb{background-color:currentColor;border-radius:9px;border:solid 6px transparent;background-clip:content-box}.kapix-image-viewer-input::-webkit-scrollbar-thumb:hover{border-width:5px}.kapix-image-viewer-input::-webkit-scrollbar{height:18px;width:18px}@media (max-width: 599.98px){.kapix-image-viewer-input::-webkit-scrollbar{height:0;width:0}}.kapix-image-viewer-input::-webkit-scrollbar:disabled{display:none}.kapix-image-viewer-input::-webkit-scrollbar-button,.kapix-image-viewer-input ::-webkit-scrollbar-corner{cursor:pointer;background:transparent}.kapix-image-viewer-input::-webkit-scrollbar-button:horizontal:decrement,.kapix-image-viewer-input::-webkit-scrollbar-button:horizontal:increment,.kapix-image-viewer-input::-webkit-scrollbar-button:vertical:decrement,.kapix-image-viewer-input::-webkit-scrollbar-button:vertical:increment{display:none}.kapix-image-viewer-input::-webkit-scrollbar-button:vertical:start:increment,.kapix-image-viewer-input::-webkit-scrollbar-button:vertical:end:decrement,.kapix-image-viewer-input::-webkit-scrollbar-button:horizontal:start:increment,.kapix-image-viewer-input::-webkit-scrollbar-button:horizontal:end:decrement{display:none}.kapix-image-viewer-input::-webkit-scrollbar-track{background:transparent}.kapix-image-viewer-input::-webkit-scrollbar-thumb:vertical{min-height:50px}.kapix-image-viewer-input::-webkit-scrollbar-thumb:horizontal{min-width:50px}.kapix-image-viewer-input .kapix-field-input{height:auto}.kapix-image-viewer-container{width:100%;height:100%;min-width:0;min-height:0;position:relative;display:flex;flex-wrap:wrap;justify-content:center;gap:10px}.kapix-image-viewer-container>img{flex-basis:350px}.kapix-upload-actions-container{width:100%;height:100%;min-width:0;min-height:0;pointer-events:none;opacity:0;background:rgba(128,128,128,.3);border:2px dashed white;border-radius:8px;display:flex;position:absolute;justify-content:center;align-items:center;transition:opacity .2s ease-in;top:0;left:0}.kapix-upload-actions-container *{pointer-events:auto}.kapix-upload-actions-container:hover,.kapix-upload-actions-container.dragging,.kapix-upload-actions-container.hover{opacity:1}
`, oe = /* @__PURE__ */ D({
  __name: "KapixImageViewerInput",
  props: Y([Array, String]),
  emits: ["update:modelValue"],
  setup(E, { emit: F }) {
    q("KapixImageViewerInput", Z);
    const p = E, M = F, l = d({
      get() {
      },
      set(i) {
      }
    }), n = d({
      get() {
        return G(p);
      },
      set(i) {
        M("update:modelValue", i);
      }
    }), S = {
      backgroundImage: W
    }, h = C(!1), V = C(!1), o = C(void 0), U = d(() => x(o.value) ? o.value : H), w = d(() => x(o.value) ? void 0 : o.value), c = d(() => x(n.value) || !!p.options.multiple), $ = d(() => p.options.showStringInput !== !1 && !c.value && (n.value == null || I(n.value)));
    let b;
    function L(i) {
      return c.value;
    }
    function B(i) {
      i && (L() ? (o.value = i.files.map((e) => e.preview).filter((e) => e), b = i.files.map((e) => e.file).filter((e) => e)) : (o.value = i.file.preview, b = i.file.file));
    }
    return typeof document < "u" && N(() => n.value, async (i) => {
      if (!T(i, b)) {
        if (b = void 0, o.value = void 0, i instanceof File) {
          const e = new FileReader();
          e.readAsDataURL(i), e.onload = (r) => {
            o.value = r.target && r.target.result;
          };
        } else if (I(i))
          o.value = i;
        else if (x(i)) {
          const e = await Promise.all(i.map(async (r) => {
            if (I(r))
              return r;
            if (r instanceof File)
              return new Promise((a) => {
                const s = new FileReader();
                s.readAsDataURL(r), s.onload = (m) => {
                  a(m.target && m.target.result);
                }, s.onerror = (m) => {
                  a(void 0);
                };
              });
          }));
          o.value = e.filter((r) => r);
        }
      }
    }, { immediate: !0 }), (i, e) => {
      const r = K("kapix-uploadcare");
      return i.editable ? (u(), f("div", {
        key: 0,
        style: S,
        class: z([i.templateClass, "kapix-image-viewer-input"])
      }, [
        t($) ? (u(), k(J, g({ key: 0 }, p, {
          modelValue: t(n),
          "onUpdate:modelValue": e[0] || (e[0] = (a) => v(n) ? n.value = a : null),
          value: t(n),
          "template-class": void 0
        }), null, 16, ["modelValue", "value"])) : O("", !0),
        A("div", {
          class: "kapix-image-viewer-container",
          onMouseenter: e[3] || (e[3] = (a) => h.value = !0),
          onMouseout: e[4] || (e[4] = (a) => h.value = !1),
          onDragenter: e[5] || (e[5] = (a) => V.value = !0),
          onMouseleave: e[6] || (e[6] = (a) => V.value = !1)
        }, [
          t(c) ? (u(!0), f(P, { key: 0 }, R(t(U), (a, s) => (u(), k(y, g({ key: s }, p, {
            modelValue: t(l),
            "onUpdate:modelValue": e[1] || (e[1] = (m) => v(l) ? l.value = m : null),
            value: a,
            "lazy-value": a,
            "template-class": ""
          }), null, 16, ["modelValue", "value", "lazy-value"]))), 128)) : (u(), k(y, g({ key: 1 }, p, {
            modelValue: t(l),
            "onUpdate:modelValue": e[2] || (e[2] = (a) => v(l) ? l.value = a : null),
            "template-class": "",
            value: t(w),
            "lazy-value": t(w)
          }), null, 16, ["modelValue", "value", "lazy-value"]))
        ], 32),
        A("div", {
          class: z(["kapix-upload-actions-container", { dragging: t(V), hover: t(h) }])
        }, [
          j(r, {
            modelValue: t(n),
            "onUpdate:modelValue": e[7] || (e[7] = (a) => v(n) ? n.value = a : null),
            options: i.options,
            "is-multiple-files": t(c),
            pubkey: i.options.pubkey || t(Q).UPLOADCARE_PUBLIC_KEY,
            "return-type": i.options.returnType,
            "media-filter": t(X).IMAGE,
            accept: i.options.accept,
            "on-change": B
          }, null, 8, ["modelValue", "options", "is-multiple-files", "pubkey", "return-type", "media-filter", "accept"])
        ], 2)
      ], 2)) : t(c) ? (u(), f("div", {
        key: 1,
        class: z(["kapix-image-viewer-container", i.templateClass])
      }, [
        (u(!0), f(P, null, R(t(U), (a, s) => (u(), k(y, g({ key: s }, p, {
          modelValue: t(l),
          "onUpdate:modelValue": e[8] || (e[8] = (m) => v(l) ? l.value = m : null),
          value: a,
          "lazy-value": a,
          "template-class": ""
        }), null, 16, ["modelValue", "value", "lazy-value"]))), 128))
      ], 2)) : (u(), k(y, g({ key: 2 }, p, {
        modelValue: t(l),
        "onUpdate:modelValue": e[9] || (e[9] = (a) => v(l) ? l.value = a : null),
        value: t(w),
        "lazy-value": t(w)
      }), null, 16, ["modelValue", "value", "lazy-value"]));
    };
  }
});
export {
  oe as default
};
